Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_qck.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 2528)
@@ -467,34 +409,50 @@
 
 
-   SUBROUTINE quickest( fu, fd, fc, fho, fc_cfl )
-      !!----------------------------------------------------------------------
-      !!
-      !!----------------------------------------------------------------------
-      REAL(wp), INTENT(in)  , DIMENSION(jpi,jpj) :: fu, fd, fc, fc_cfl  
-      REAL(wp), INTENT(out) , DIMENSION(jpi,jpj) :: fho
-      REAL(wp)              , DIMENSION(jpi,jpj) :: zcurv, zcoef1, zcoef2, zcoef3  ! temporary scalars
-      !
-      zcurv (:,:) = fd(:,:) + fu(:,:) - 2.*fc(:,:)
-      zcoef1(:,:) = 0.5*( fc(:,:) + fd(:,:) )
-      zcoef2(:,:) = 0.5*fc_cfl(:,:)*( fd(:,:) - fc(:,:) )
-      zcoef3(:,:) = ( ( 1. - ( fc_cfl(:,:)*fc_cfl(:,:) ) )*r1_6 )*zcurv(:,:)
-      fho   (:,:) = zcoef1(:,:) - zcoef2(:,:) - zcoef3(:,:)                         ! phi_f QUICKEST 
-      !
-      zcoef1(:,:) = fd(:,:) - fu(:,:)                                               ! DEL
-      zcoef2(:,:) = ABS( zcoef1(:,:) )                                              ! ABS(DEL)
-      zcoef3(:,:) = ABS( zcurv(:,:) )                                               ! ABS(CURV)
-      !
-      WHERE ( zcoef3(:,:) >= zcoef2(:,:) ) 
-        fho(:,:) = fc(:,:)
-      ELSEWHERE
-        zcoef3(:,:) = fu(:,:) + ( ( fc(:,:) - fu(:,:) )/MAX(fc_cfl(:,:),1.e-9) )    ! phi_REF
-          WHERE ( zcoef1(:,:) >= 0.e0 )
-            fho(:,:) = MAX(fc(:,:),fho(:,:))
-            fho(:,:) = MIN(fho(:,:),MIN(zcoef3(:,:),fd(:,:)))
-          ELSEWHERE
-            fho(:,:) = MIN(fc(:,:),fho(:,:))
-            fho(:,:) = MAX(fho(:,:),MAX(zcoef3(:,:),fd(:,:)))
-          ENDWHERE
-      ENDWHERE
+   SUBROUTINE quickest( pfu, pfd, pfc, puc )
+      !!----------------------------------------------------------------------
+      !!
+      !! ** Purpose :  Computation of advective flux with Quickest scheme
+      !!
+      !! ** Method :   
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   pfu   ! second upwind point
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   pfd   ! first douwning point
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   pfc   ! the central point (or the first upwind point)
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   puc   ! input as Courant number ; output as flux
+      !!
+      INTEGER  ::  ji, jj, jk               ! dummy loop indices 
+      REAL(wp) ::  zcoef1, zcoef2, zcoef3   ! local scalars          
+      REAL(wp) ::  zc, zcurv, zfho          !   -      -
+      !----------------------------------------------------------------------
+
+      DO jk = 1, jpkm1
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               zc     = puc(ji,jj,jk)                         ! Courant number
+               zcurv  = pfd(ji,jj,jk) + pfu(ji,jj,jk) - 2. * pfc(ji,jj,jk)
+               zcoef1 = 0.5 *      ( pfc(ji,jj,jk) + pfd(ji,jj,jk) )
+               zcoef2 = 0.5 * zc * ( pfd(ji,jj,jk) - pfc(ji,jj,jk) )
+               zcoef3 = ( 1. - ( zc * zc ) ) * r1_6 * zcurv
+               zfho   = zcoef1 - zcoef2 - zcoef3              !  phi_f QUICKEST 
+               !
+               zcoef1 = pfd(ji,jj,jk) - pfu(ji,jj,jk)
+               zcoef2 = ABS( zcoef1 )
+               zcoef3 = ABS( zcurv )
+               IF( zcoef3 >= zcoef2 ) THEN
+                  zfho = pfc(ji,jj,jk) 
+               ELSE
+                  zcoef3 = pfu(ji,jj,jk) + ( ( pfc(ji,jj,jk) - pfu(ji,jj,jk) ) / MAX( zc, 1.e-9 ) )    ! phi_REF
+                  IF( zcoef1 >= 0. ) THEN
+                     zfho = MAX( pfc(ji,jj,jk), zfho ) 
+                     zfho = MIN( zfho, MIN( zcoef3, pfd(ji,jj,jk) ) ) 
+                  ELSE
+                     zfho = MIN( pfc(ji,jj,jk), zfho ) 
+                     zfho = MAX( zfho, MAX( zcoef3, pfd(ji,jj,jk) ) ) 
+                  ENDIF
+               ENDIF
+               puc(ji,jj,jk) = zfho
+            END DO
+         END DO
+      END DO
       !
    END SUBROUTINE quickest
